/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "defaults.h"

#include "hexdump.h"
#include "stdio.h"

void hexdump(void *d, int Length)
{
   __u8 *Data=(__u8*)d;
   int i,j;
   for (i=0;i<Length;i+=16) {
      printf("  %03X  -- ",i);
      for (j=0;j<16;j++) {
         if (i+j<Length) {
            printf("%02x ",Data[i+j]);
         } else {
            printf("   ");
         }
         if (j==7)
            printf("  ");
      }
      printf("    ");
      for (j=0;j<16;j++) {
         if (i+j<Length) {
            unsigned char c=Data[i+j];
            if (c >= 0x20)
               printf("%c",c);
            else
               printf(".");
         } else {
            printf(" ");
         }
         if (j==7)
            printf("  ");
      }
      printf("\n");
   }
}
