/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INFOSATDATA_H
#define INFOSATDATA_H

#define EPG_FIRST_DAY_MAC 1
#define EPG_LAST_DAY_MAC 7

#define EPG_DAYS 7
#define EPG_STATUS_SIZE 2048

struct infosathdr {
	__u16	TechnisatID;
	__u8	TableID;
	__u8	TableSubID;
	__u8    data[4];
	__u16	pktnr;
	__u16	pktcount;
};

struct tInfosat {
  struct tMPE* m_mpe;
  struct infosathdr* m_header;
  __u8* m_content;
  int m_content_length;
  int m_mac;
  int m_packetNumber;
  int m_packetCount;
};

struct tInfosatMMapStream {
  int m_day;
  int m_month;
  int m_goodPackets;
  int m_packetCount;
  __u8 m_blocks[EPG_STATUS_SIZE];
};

struct tInfosatMMapHead {
    int m_packetCount;
    int m_goodPackets;
    double m_percentFinished;
    tInfosatMMapStream m_streams[EPG_DAYS];
};

#endif
