/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INFOSATDECODER_H
#define INFOSATDECODER_H

#include <iostream>
using std::ostream;
#include <time.h>

#include "mpedata.h"
#include "infosatdata.h"
#include "objreceiver.h"
#include "objsender.h"
#include "mmapfile.h"
#include "infosatstream.h"

/**
@author Matthias Schwarzott
*/
class cInfosatDecoder : public cMMapFile, public cObjReceiver<tMPE>, public cObjSender<tInfosat> {
public:
    cInfosatDecoder();

    ~cInfosatDecoder();

    virtual bool Receive(tMPE& mpe);
    
    void printStatus(ostream &os);
    void resetEPG(int mac, int day, int month);
    tInfosatMMapStream* getEPGStreamStatus(int mac);
    
    inline cInfosatStream& epg(int mac)
    {
      return m_epg[mac-EPG_FIRST_DAY_MAC];
    }
    void updateStatistics(void);
     
    void setPacketReceived();
private:
    cInfosatStream m_epg[EPG_DAYS];
    tInfosatMMapHead* m_mmapHead;
    
    time_t m_startTime;
    time_t m_lastPacketReceivedTime;
    time_t m_packetTimeout;
};

#endif
