/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CINFOSATSTREAM_H
#define CINFOSATSTREAM_H

#include <iostream>
#include <fstream>
#include <string>

using std::ofstream;
using std::ostream;
using std::string;

#include "defaults.h"
#include "objreceiver.h"
#include "infosatdata.h"

/**
@author Matthias Schwarzott
*/
class cInfosatStream : public cObjReceiver<tInfosat> {
public:
    cInfosatStream();

    ~cInfosatStream();
    
    void initialize(class cInfosatDecoder *decoder, int mac, bool keepData);
    virtual bool Receive(tInfosat& is);
    
    bool isEmpty(void) { return (m_status->m_goodPackets == 0); };
    bool isDateEmpty(void) { return (m_status->m_day == 0); };
    bool isFinished(void) { return (m_status->m_goodPackets == m_status->m_packetCount); };
    void reset(int day, int month);
    void printStatus(ostream &os);

    void openFile(void);
    void closeFile(void);
    int getPacketCount(void) { return m_status->m_packetCount; }
    int getGoodPackets(void) { return m_status->m_goodPackets; }
protected:
    int m_mac;
//    int m_packetCount;
//    int m_goodPackets;
//    int m_day;
    int m_month;
    tInfosatMMapStream* m_status;
    class cInfosatDecoder *m_decoder;
    
    bool m_keepData;
    int m_output_fd;
    string m_filename;
    static int last_mac;
    static int last_packet;
};

#endif
