/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sstream>
#include <iostream>
using namespace std;

#include "defaults.h"
#include "mmapfile.h"

cMMapFile::cMMapFile(const char *fname, int size, char *id, int id_len)
{
  m_mmapID=id;
  m_mmapID_len=id_len;
  ostringstream fnameStream;
  fnameStream << output_dir << "/" << fname;
  m_mmapFile=fnameStream.str();

  m_mmapSize=size+id_len;

  struct stat stat_buf;
  if (stat(m_mmapFile.c_str(), &stat_buf)==0) {
      m_mmapCreatedNew=false;
  } else {
      m_mmapCreatedNew=true;
  }
  int fd=open(m_mmapFile.c_str(), O_RDWR | O_CREAT, 0644);
  ftruncate(fd, m_mmapSize);
  m_mmapData=(__u8*)mmap(0, m_mmapSize, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);  
  close(fd);
  

  bool goodID=true;
  for (int i=0;i<m_mmapID_len;i++)
    if (m_mmapData[i]!=m_mmapID[i])
      goodID=false;
  
  if (!goodID) {
    m_mmapCreatedNew=true;
    for (int i=0;i<m_mmapID_len;i++)
      m_mmapData[i]=m_mmapID[i];
  }
}


cMMapFile::~cMMapFile()
{
  if (m_mmapData) {
    munmap(m_mmapData, m_mmapSize);
    m_mmapData=NULL;
  }
}

__u8* cMMapFile::getMMAPData(void)
{
  return m_mmapData+m_mmapID_len;
}

void cMMapFile::deleteMMapFile(void)
{
  unlink(m_mmapFile.c_str());
}
