/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OBJSENDER_H
#define OBJSENDER_H

#include <list>
#include "objreceiver.h"

//template<typename X> class cObjReceiver;

/**
@author Matthias Schwarzott
*/
template<typename X> class cObjSender {
public:
    //bool m_first_only;
    typedef cObjReceiver<X> myReceiver;
    typedef typename std::list<myReceiver*> myReceiverList;
    typedef typename myReceiverList::iterator myReceiverIterator;
    
    cObjSender()
    {
      //m_first_only=false;
    }
    
    inline bool Send(X& obj)
    {
      bool catched=false;
      for (myReceiverIterator it=receiver.begin(); it != receiver.end(); ++it)
        if ((*it)->Receive(obj))
          catched=true;
      return catched;
    }
    
    inline void Attach(myReceiver *_rec) 
    {
      receiver.insert(receiver.end(),_rec);
    }

    inline void Detach(myReceiver *_rec)
    {
      receiver.remove(_rec);
    }

private:
    std::list<myReceiver*> receiver;
};

#endif
