/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "sectiondecoder.h"
#include "hexdump.h"

void cSectionDecoder::Process(__u8 *data, int length)
{
  tSection s;
  s.data=data;
  
  // Check length in Header
  int section_len = ((data[1] & 0xF) << 8) | (data[2]) ;
  section_len += 3;/* 3 bytes before length count starts */
  if (section_len>length) {
    return;
  }
  s.length=length=section_len;
  s.table_id=data[0];

  // Header: 12
  // CRC: 4
  s.content=data+12;
  s.content_length=length-12-4;
  
  Send(s);
}

    
