/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <iostream>

#include "defaults.h"
#include "sectionfile.h"

using namespace std;
cSectionFile::cSectionFile(char *_fname)
{
	fname=_fname;
	input_fd=-1;
}

cSectionFile::~cSectionFile()
{
	Close();
}

bool cSectionFile::Open()
{
	if ((input_fd = open(fname, O_RDWR)) < 0) {
		perror("open input file");
		return false;
	}
	return true;
}

void cSectionFile::Close()
{
	if (input_fd!=-1)
	{
		close(input_fd);
		input_fd=-1;
	}
}

void cSectionFile::Action()
{
	__u8 buf[32*1024];
	int sect_len;
	Open();
	cerr << "Start receiving from " << fname << endl;
	while (1) {
		int tmp;
		tmp=read(input_fd, buf, 3);
		if (tmp!=3) {
			if (tmp==0) {
				setExit("sectionfile","End of file reached");
				return;
			}
			if (tmp<0) {
				setExit("sectionfile","Error: read from file");
				return;
			}
		}
		sect_len=((buf[1] & 0x0F) << 8) + buf[2];

		if (sizeof(buf)<sect_len) {
			setExit("sectionfile", "error: Buffer to small");
			return;
		}
		tmp=read(input_fd, buf+3, sect_len);
		if (tmp!=sect_len) {
			setExit("sectionfile", "error: Could not read complete section");
			return;
		}
		if (sect_len>0) {
			Process(buf,sect_len+3);
			if (verbose_level>2) {
				usleep(4000);
			}
		}
	}
	Close();
}

