/***************************************************************************
 *   Copyright (C) 2004-2005 by Matthias Schwarzott                        *
 *   zzam@gmx.de                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <iostream>
#include <sys/types.h>
#include <unistd.h>

#include "thread.h"

using namespace std;

cThread::cThread(void)
{
    parentTid = childTid = 0;
}

cThread::~cThread(void)
{
}

void *cThread::StartThread(cThread *Thread)
{
    Thread->childTid = pthread_self();
    // cerr << "thread started (pid=" << getpid() << ",tid=" << Thread->childTid << ")" << endl;
    Thread->Action();
    // cerr << "thread ended (pid=" << getpid() << ",tid=" << Thread->childTid << ")" << endl;
    Thread->childTid = 0;
    return NULL;
}

void cThread::Start(void)
{
    if (!childTid) {
        parentTid = pthread_self();
        pthread_create(&childTid, NULL, (void *(*) (void *))&StartThread, (void *)this);
        pthread_detach(childTid); // auto-reap
        pthread_setschedparam(childTid, SCHED_RR, 0);
    }
}

